using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Xml.Serialization;
using NLog;
using System.IO;
using System.Collections;

namespace ChatSystem
{
    [Serializable]
    public class IdLibrary
    {
        #region Constants

        public static string CLASS_NAME = typeof(IdLibrary).ToString();

        // Effectively a constant
        private static Logger logger = LogManager.GetCurrentClassLogger();

        #endregion

        #region Library Constants

        // Result code for 3 possible results
        public enum TriResult { SUCCESS, NOTFOUND, FAIL };

        #endregion

        #region Library Routines

        /// <summary>
        /// Return true on NOTFOUND or ERROR.
        /// </summary>
        /// <param name="aTableName">Table name to drop</param>
        public static bool AnyIdError(TriResult aResult)
        {
            if (aResult != TriResult.SUCCESS)
                return true;
            else
                return false;
        }

        #region Support

        /// <summary>
        /// Return true if we should try to log, false if not.
        /// </summary>
        /// <param name="aLogger"></param>
        /// <param name="aLevel"></param>
        /// <returns></returns>
        public static bool WithinLoggerLevel(LogLevel aLevel)
        {
            if (aLevel == LogLevel.Trace && logger.IsTraceEnabled == true)
                return true;

            else if (aLevel == LogLevel.Debug && logger.IsDebugEnabled == true)
                return true;

            else if (aLevel == LogLevel.Info && logger.IsInfoEnabled == true)
                return true;

            else if (aLevel == LogLevel.Warn && logger.IsWarnEnabled == true)
                return true;

            else if (aLevel == LogLevel.Error)
                return true;

            else
                return false;
        }

        #endregion

        #endregion

        #region Common Routines

        // Force utf-8 instead of 16
        public class Utf8StringWriter : StringWriter
        {
            public override Encoding Encoding
            {
                get { return Encoding.UTF8; }
            }
        }

        #endregion

    }
}
